package Dates.Test is

   type Test_Vector is array (Positive range <>) of Date;

   function Is_Valid (TV : Test_Vector) return Boolean is
     (TV'Length > 0 and (for all D of TV => D.Is_Valid));
   function Is_All_In_The_Same_Year (TV : Test_Vector) return Boolean is
     (for all J in TV'Range => TV (J).Year = TV (TV'First).Year);
   
   subtype Test_Vector_Limited_Size is Natural range 1 .. 10;
   type Test_Setup (Size : Test_Vector_Limited_Size := 1) is record
      TV : Test_Vector (1 .. Size);
      Expect_Valid : Boolean;
      Expect_Same_Year : Boolean;
   end record;
   
   type Test_Setup_Array is array (Positive range <>) of Test_Setup;
   
end Dates.Test;
