package Dates is
   
   type Day_T is range 1 .. 31;
   type Month_T is (Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec);
   
   type Days_In_Month_T is array (Month_T) of Day_T;
   Month_Max_Day : constant array (Boolean) of Days_In_Month_T
     := (
         False => (31, 28, 31, 30, 31, 30, 31, 30, 31, 31, 30, 31),
         True  => (31, 29, 31, 30, 31, 30, 31, 30, 31, 31, 30, 31)
        );

   type Date is tagged record
      Day : Day_T;
      Month : Month_T;
      Year : Natural range 0 .. 9999;
   end record;
   
   function Is_Leap_Year (D : Date) return Boolean
   is (D.Year mod 4 = 0 and
         (not (D.Year mod 100 = 0)
           or (D.Year mod 400 = 0)));
   
   function Is_Valid (D : Date) return Boolean
   is (D.Day <= Month_Max_Day (D.Is_Leap_Year)(D.Month));
   
   function "+" (D : Date) return String
   is (D.Day'Img & " / " & D.Month'Img & " / " & D.Year'Img);
   
end Dates;
