with Ada.Text_IO; use Ada.Text_IO;
with Dates; use Dates;
with Dates.Test; use Dates.Test;

procedure Main is
   TSA : Test_Setup_Array
     := (
         (
          Size => 1,
          TV => ( 1 => (12, Feb, 2022) ),
          Expect_Same_Year => True, Expect_Valid => True
          ),
         (
          Size => 2,
          TV => ( (12, Feb, 2022), (12, Feb, 2023) ),
          Expect_Same_Year => False, Expect_Valid => True
          ),
         (
          Size => 2,
          TV => ( (29, Feb, 2022), (12, Feb, 2023) ),
          Expect_Same_Year => False, Expect_Valid => False
          ),
         (
          Size => 2,
          TV => ( (29, Feb, 1900), (1, Jan, 1900) ),
          Expect_Same_Year => True, Expect_Valid => False
          ),
         (
          Size => 3,
          TV => ( (31, Apr, 1900), (1, Jan, 1901), (1, Jun, 1902) ),
          Expect_Same_Year => False, Expect_Valid => False
          )
         );
begin
   for TS of TSA loop
      for J in TS.TV'Range loop
         Put_Line (+TS.TV (J));
      end loop;

      pragma Assert (Is_Valid (TS.TV) = TS.Expect_Valid);
      pragma Assert (Is_All_In_The_Same_Year (TS.TV) = TS.Expect_Same_Year);
      Put_Line (Character'Val(8#33#) & "[32mOK" & Character'Val(8#33#) & "[0m");
   end loop;
end Main;
