pragma Ada_2005;
pragma Style_Checks (Off);

with Interfaces.C; use Interfaces.C;
with Interfaces.C.Extensions;
with System;

package cppconfig_h is

   LT_OBJDIR : aliased constant String := ".libs/" & ASCII.NUL;  --  d:\install\gpl2018\include\c++\7.3.1\x86_64-pc-mingw32\bits\c++config.h:1352

   STDC_HEADERS : constant := 1;  --  d:\install\gpl2018\include\c++\7.3.1\x86_64-pc-mingw32\bits\c++config.h:1391
   --  unsupported macro: finitef _finitef
   --  unsupported macro: isnanf _isnanf

  -- Predefined symbols and macros -*- C++ -*-
  -- Copyright (C) 1997-2017 Free Software Foundation, Inc.
  -- This file is part of the GNU ISO C++ Library.  This library is free
  -- software; you can redistribute it and/or modify it under the
  -- terms of the GNU General Public License as published by the
  -- Free Software Foundation; either version 3, or (at your option)
  -- any later version.
  -- This library is distributed in the hope that it will be useful,
  -- but WITHOUT ANY WARRANTY; without even the implied warranty of
  -- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  -- GNU General Public License for more details.
  -- Under Section 7 of GPL version 3, you are granted additional
  -- permissions described in the GCC Runtime Library Exception, version
  -- 3.1, as published by the Free Software Foundation.
  -- You should have received a copy of the GNU General Public License and
  -- a copy of the GCC Runtime Library Exception along with this program;
  -- see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
  -- <http://www.gnu.org/licenses/>.
  --* @file bits/c++config.h
  -- *  This is an internal header file, included by other library headers.
  -- *  Do not attempt to use it directly. @headername{iosfwd}
  --  

  -- The major release number for the GCC release the C++ library belongs to.
  -- The datestamp of the C++ library in compressed ISO date format.
  -- Macros for various attributes.
  --   _GLIBCXX_PURE
  --   _GLIBCXX_CONST
  --   _GLIBCXX_NORETURN
  --   _GLIBCXX_NOTHROW
  --   _GLIBCXX_VISIBILITY
  -- See below for C++
  -- Macros for visibility attributes.
  --   _GLIBCXX_HAVE_ATTRIBUTE_VISIBILITY
  --   _GLIBCXX_VISIBILITY
  -- If this is not supplied by the OS-specific or CPU-specific
  -- headers included below, it will be defined to an empty default.
  -- Macros for deprecated attributes.
  --   _GLIBCXX_USE_DEPRECATED
  --   _GLIBCXX_DEPRECATED
  -- Macros for ABI tag attributes.
  -- Macro for constexpr, to support in mixed 03/0x mode.
  -- Macro for noexcept, to support in mixed 03/0x mode.
  -- Macro for extern template, ie controlling template linkage via use
  -- of extern keyword on template declaration. As documented in the g++
  -- manual, it inhibits all implicit instantiations and is used
  -- throughout the library to avoid multiple weak definitions for
  -- required types that are already explicitly instantiated in the
  -- library binary. This substantially reduces the binary size of
  -- resulting executables.
  -- Special case: _GLIBCXX_EXTERN_TEMPLATE == -1 disallows extern
  -- templates only in basic_string, thus activating its debug-mode
  -- checks even at -O0.
  --  Outline of libstdc++ namespaces.
  --  namespace std
  --  {
  --    namespace __debug { }
  --    namespace __parallel { }
  --    namespace __profile { }
  --    namespace __cxx1998 { }
  --    namespace __detail {
  --      namespace __variant { }				// C++17
  --    }
  --    namespace rel_ops { }
  --    namespace tr1
  --    {
  --      namespace placeholders { }
  --      namespace regex_constants { }
  --      namespace __detail { }
  --    }
  --    namespace tr2 { }
  --    
  --    namespace decimal { }
  --    namespace chrono { }				// C++11
  --    namespace placeholders { }				// C++11
  --    namespace regex_constants { }			// C++11
  --    namespace this_thread { }				// C++11
  --    inline namespace literals {				// C++14
  --      inline namespace chrono_literals { }		// C++14
  --      inline namespace complex_literals { }		// C++14
  --      inline namespace string_literals { }		// C++14
  --      inline namespace string_view_literals { }		// C++17
  --    }
  --  }
  --  namespace abi { }
  --  namespace __gnu_cxx
  --  {
  --    namespace __detail { }
  --  }
  --  For full details see:
  --  http://gcc.gnu.org/onlinedocs/libstdc++/latest-doxygen/namespaces.html
  -- 

   subtype size_t is Extensions.unsigned_long_long;  -- d:\install\gpl2018\include\c++\7.3.1\x86_64-pc-mingw32\bits\c++config.h:231

   subtype ptrdiff_t is Long_Long_Integer;  -- d:\install\gpl2018\include\c++\7.3.1\x86_64-pc-mingw32\bits\c++config.h:232

   subtype nullptr_t is System.Address;  -- d:\install\gpl2018\include\c++\7.3.1\x86_64-pc-mingw32\bits\c++config.h:235

  -- Ignore any pre-defined value of _GLIBCXX_USE_CXX11_ABI
  -- Defined if inline namespaces are used for versioning.
  -- Inline namespace for symbol versioning.
  -- Inline namespaces for special modes: debug, parallel, profile.
  -- Non-inline namespace for components replaced by alternates in active mode.
  -- Inline namespace for debug mode.
  -- Inline namespaces for parallel mode.
  -- Inline namespaces for profile mode
  -- Check for invalid usage and unsupported mixed-mode use.
  -- Check for invalid use due to lack for weak symbols.
  -- Macros for namespace scope. Either namespace std:: or the name
  -- of some nested namespace within it corresponding to the active mode.
  -- _GLIBCXX_STD_A
  -- _GLIBCXX_STD_C
  -- Macros for opening/closing conditional namespaces.
  -- _GLIBCXX_BEGIN_NAMESPACE_ALGO
  -- _GLIBCXX_END_NAMESPACE_ALGO
  -- _GLIBCXX_BEGIN_NAMESPACE_CONTAINER
  -- _GLIBCXX_END_NAMESPACE_CONTAINER
  -- GLIBCXX_ABI Deprecated
  -- Define if compatibility should be provided for -mlong-double-64.
  -- Inline namespace for long double 128 mode.
  -- Debug Mode implies checking assertions.
  -- Disable std::string explicit instantiation declarations in order to assert.
  -- Assert.
  -- Avoid the use of assert, because we're trying to keep the <cassert>
  -- include out of the mix.
  -- Macros for race detectors.
  -- _GLIBCXX_SYNCHRONIZATION_HAPPENS_BEFORE(A) and
  -- _GLIBCXX_SYNCHRONIZATION_HAPPENS_AFTER(A) should be used to explain
  -- atomic (lock-free) synchronization to race detectors:
  -- the race detector will infer a happens-before arc from the former to the
  -- latter when they share the same argument pointer.
  -- The most frequent use case for these macros (and the only case in the
  -- current implementation of the library) is atomic reference counting:
  --   void _M_remove_reference()
  --   {
  --     _GLIBCXX_SYNCHRONIZATION_HAPPENS_BEFORE(&this->_M_refcount);
  --     if (__gnu_cxx::__exchange_and_add_dispatch(&this->_M_refcount, -1) <= 0)
  --       {
  --         _GLIBCXX_SYNCHRONIZATION_HAPPENS_AFTER(&this->_M_refcount);
  --         _M_destroy(__a);
  --       }
  --   }
  -- The annotations in this example tell the race detector that all memory
  -- accesses occurred when the refcount was positive do not race with
  -- memory accesses which occurred after the refcount became zero.
  -- Macros for C linkage: define extern "C" linkage only when using C++.
  -- First includes.
  -- Pick up any OS-specific definitions.
  -- Pick up any CPU-specific definitions.
  -- If platform uses neither visibility nor psuedo-visibility,
  -- specify empty default for namespace annotation macros.
  -- Certain function definitions that are meant to be overridable from
  -- user code are decorated with this macro.  For some targets, this
  -- macro causes these definitions to be weak.
  -- By default, we assume that __GXX_WEAK__ also means that there is support
  -- for declaring functions as weak while not defining such functions.  This
  -- allows for referring to functions provided by other libraries (e.g.,
  -- libitm) without depending on them if the respective features are not used.
  -- Conditionally enable annotations for the Transactional Memory TS on C++11.
  -- Most of the following conditions are due to limitations in the current
  -- implementation.
  -- In C++17 mathematical special functions are in namespace std.
  -- For C++11 and C++14 they are in namespace std when requested.
  -- The remainder of the prewritten config is automatic; all the
  -- user hooks are listed above.
  -- Create a boolean flag to be used to determine if --fast-math is set.
  -- This marks string literals in header files to be extracted for eventual
  -- translation.  It is primarily used for messages in thrown exceptions; see
  -- src/functexcept.cc.  We use __N because the more traditional _N is used
  -- for something else under certain OSes (see BADNAMES).
  -- For example, <windows.h> is known to #define min and max as macros...
  -- N.B. these _GLIBCXX_USE_C99_XXX macros are defined unconditionally
  -- so they should be tested with #if not with #ifdef.
  -- End of prewritten config; the settings discovered at configure time follow.
  -- config.h.  Generated from config.h.in by configure.   
  -- config.h.in.  Generated from configure.ac by autoheader.   
  -- Define to 1 if you have the `acosf' function.  
  -- Define to 1 if you have the `acosl' function.  
  -- Define to 1 if you have the `aligned_alloc' function.  
  -- #undef _GLIBCXX_HAVE_ALIGNED_ALLOC  
  -- Define to 1 if you have the `asinf' function.  
  -- Define to 1 if you have the `asinl' function.  
  -- Define to 1 if the target assembler supports .symver directive.  
  -- #undef _GLIBCXX_HAVE_AS_SYMVER_DIRECTIVE  
  -- Define to 1 if you have the `atan2f' function.  
  -- Define to 1 if you have the `atan2l' function.  
  -- Define to 1 if you have the `atanf' function.  
  -- Define to 1 if you have the `atanl' function.  
  -- Define to 1 if you have the `at_quick_exit' function.  
  -- #undef _GLIBCXX_HAVE_AT_QUICK_EXIT  
  -- Define to 1 if the target assembler supports thread-local storage.  
  -- #undef _GLIBCXX_HAVE_CC_TLS  
  -- Define to 1 if you have the `ceilf' function.  
  -- Define to 1 if you have the `ceill' function.  
  -- Define to 1 if you have the <complex.h> header file.  
  -- Define to 1 if you have the `cosf' function.  
  -- Define to 1 if you have the `coshf' function.  
  -- Define to 1 if you have the `coshl' function.  
  -- Define to 1 if you have the `cosl' function.  
  -- Define to 1 if you have the <dirent.h> header file.  
  -- Define to 1 if you have the <dlfcn.h> header file.  
  -- #undef _GLIBCXX_HAVE_DLFCN_H  
  -- Define if EBADMSG exists.  
  -- #undef _GLIBCXX_HAVE_EBADMSG  
  -- Define if ECANCELED exists.  
  -- Define if ECHILD exists.  
  -- Define if EIDRM exists.  
  -- #undef _GLIBCXX_HAVE_EIDRM  
  -- Define to 1 if you have the <endian.h> header file.  
  -- #undef _GLIBCXX_HAVE_ENDIAN_H  
  -- Define if ENODATA exists.  
  -- #undef _GLIBCXX_HAVE_ENODATA  
  -- Define if ENOLINK exists.  
  -- #undef _GLIBCXX_HAVE_ENOLINK  
  -- Define if ENOSPC exists.  
  -- Define if ENOSR exists.  
  -- #undef _GLIBCXX_HAVE_ENOSR  
  -- Define if ENOSTR exists.  
  -- #undef _GLIBCXX_HAVE_ENOSTR  
  -- Define if ENOTRECOVERABLE exists.  
  -- #undef _GLIBCXX_HAVE_ENOTRECOVERABLE  
  -- Define if ENOTSUP exists.  
  -- Define if EOVERFLOW exists.  
  -- Define if EOWNERDEAD exists.  
  -- Define if EPERM exists.  
  -- Define if EPROTO exists.  
  -- Define if ETIME exists.  
  -- #undef _GLIBCXX_HAVE_ETIME  
  -- Define if ETIMEDOUT exists.  
  -- Define if ETXTBSY exists.  
  -- #undef _GLIBCXX_HAVE_ETXTBSY  
  -- Define if EWOULDBLOCK exists.  
  -- Define to 1 if GCC 4.6 supported std::exception_ptr for the target  
  -- Define to 1 if you have the <execinfo.h> header file.  
  -- #undef _GLIBCXX_HAVE_EXECINFO_H  
  -- Define to 1 if you have the `expf' function.  
  -- Define to 1 if you have the `expl' function.  
  -- Define to 1 if you have the `fabsf' function.  
  -- Define to 1 if you have the `fabsl' function.  
  -- Define to 1 if you have the <fcntl.h> header file.  
  -- Define to 1 if you have the <fenv.h> header file.  
  -- Define to 1 if you have the `finite' function.  
  -- Define to 1 if you have the `finitef' function.  
  -- #undef _GLIBCXX_HAVE_FINITEF  
  -- Define to 1 if you have the `finitel' function.  
  -- #undef _GLIBCXX_HAVE_FINITEL  
  -- Define to 1 if you have the <float.h> header file.  
  -- Define to 1 if you have the `floorf' function.  
  -- Define to 1 if you have the `floorl' function.  
  -- Define to 1 if you have the `fmodf' function.  
  -- Define to 1 if you have the `fmodl' function.  
  -- Define to 1 if you have the `fpclass' function.  
  -- Define to 1 if you have the <fp.h> header file.  
  -- #undef _GLIBCXX_HAVE_FP_H  
  -- Define to 1 if you have the `frexpf' function.  
  -- Define to 1 if you have the `frexpl' function.  
  -- Define if _Unwind_GetIPInfo is available.  
  -- Define if gets is available in <stdio.h> before C++14.  
  -- Define to 1 if you have the `hypot' function.  
  -- Define to 1 if you have the `hypotf' function.  
  -- Define to 1 if you have the `hypotl' function.  
  -- Define if you have the iconv() function.  
  -- #undef _GLIBCXX_HAVE_ICONV  
  -- Define to 1 if you have the <ieeefp.h> header file.  
  -- #undef _GLIBCXX_HAVE_IEEEFP_H  
  -- Define if int64_t is available in <stdint.h>.  
  -- Define if int64_t is a long.  
  -- #undef _GLIBCXX_HAVE_INT64_T_LONG  
  -- Define if int64_t is a long long.  
  -- Define to 1 if you have the <inttypes.h> header file.  
  -- Define to 1 if you have the `isinf' function.  
  -- #undef _GLIBCXX_HAVE_ISINF  
  -- Define to 1 if you have the `isinff' function.  
  -- #undef _GLIBCXX_HAVE_ISINFF  
  -- Define to 1 if you have the `isinfl' function.  
  -- #undef _GLIBCXX_HAVE_ISINFL  
  -- Define to 1 if you have the `isnan' function.  
  -- Define to 1 if you have the `isnanf' function.  
  -- #undef _GLIBCXX_HAVE_ISNANF  
  -- Define to 1 if you have the `isnanl' function.  
  -- #undef _GLIBCXX_HAVE_ISNANL  
  -- Defined if iswblank exists.  
  -- Define if LC_MESSAGES is available in <locale.h>.  
  -- #undef _GLIBCXX_HAVE_LC_MESSAGES  
  -- Define to 1 if you have the `ldexpf' function.  
  -- Define to 1 if you have the `ldexpl' function.  
  -- Define to 1 if you have the <libintl.h> header file.  
  -- #undef _GLIBCXX_HAVE_LIBINTL_H  
  -- Only used in build directory testsuite_hooks.h.  
  -- #undef _GLIBCXX_HAVE_LIMIT_AS  
  -- Only used in build directory testsuite_hooks.h.  
  -- #undef _GLIBCXX_HAVE_LIMIT_DATA  
  -- Only used in build directory testsuite_hooks.h.  
  -- #undef _GLIBCXX_HAVE_LIMIT_FSIZE  
  -- Only used in build directory testsuite_hooks.h.  
  -- #undef _GLIBCXX_HAVE_LIMIT_RSS  
  -- Only used in build directory testsuite_hooks.h.  
  -- #undef _GLIBCXX_HAVE_LIMIT_VMEM  
  -- Define if futex syscall is available.  
  -- #undef _GLIBCXX_HAVE_LINUX_FUTEX  
  -- Define to 1 if you have the <locale.h> header file.  
  -- Define to 1 if you have the `log10f' function.  
  -- Define to 1 if you have the `log10l' function.  
  -- Define to 1 if you have the `logf' function.  
  -- Define to 1 if you have the `logl' function.  
  -- Define to 1 if you have the <machine/endian.h> header file.  
  -- #undef _GLIBCXX_HAVE_MACHINE_ENDIAN_H  
  -- Define to 1 if you have the <machine/param.h> header file.  
  -- #undef _GLIBCXX_HAVE_MACHINE_PARAM_H  
  -- Define if mbstate_t exists in wchar.h.  
  -- Define to 1 if you have the `memalign' function.  
  -- #undef _GLIBCXX_HAVE_MEMALIGN  
  -- Define to 1 if you have the <memory.h> header file.  
  -- Define to 1 if you have the `modf' function.  
  -- Define to 1 if you have the `modff' function.  
  -- Define to 1 if you have the `modfl' function.  
  -- Define to 1 if you have the <nan.h> header file.  
  -- #undef _GLIBCXX_HAVE_NAN_H  
  -- Define if <math.h> defines obsolete isinf function.  
  -- #undef _GLIBCXX_HAVE_OBSOLETE_ISINF  
  -- Define if <math.h> defines obsolete isnan function.  
  -- #undef _GLIBCXX_HAVE_OBSOLETE_ISNAN  
  -- Define if poll is available in <poll.h>.  
  -- #undef _GLIBCXX_HAVE_POLL  
  -- Define to 1 if you have the `posix_memalign' function.  
  -- #undef _GLIBCXX_HAVE_POSIX_MEMALIGN  
  -- Define to 1 if you have the `powf' function.  
  -- Define to 1 if you have the `powl' function.  
  -- Define to 1 if you have the `qfpclass' function.  
  -- #undef _GLIBCXX_HAVE_QFPCLASS  
  -- Define to 1 if you have the `quick_exit' function.  
  -- #undef _GLIBCXX_HAVE_QUICK_EXIT  
  -- Define to 1 if you have the `setenv' function.  
  -- #undef _GLIBCXX_HAVE_SETENV  
  -- Define to 1 if you have the `sincos' function.  
  -- Define to 1 if you have the `sincosf' function.  
  -- Define to 1 if you have the `sincosl' function.  
  -- Define to 1 if you have the `sinf' function.  
  -- Define to 1 if you have the `sinhf' function.  
  -- Define to 1 if you have the `sinhl' function.  
  -- Define to 1 if you have the `sinl' function.  
  -- Defined if sleep exists.  
  -- Define to 1 if you have the `sqrtf' function.  
  -- Define to 1 if you have the `sqrtl' function.  
  -- Define to 1 if you have the <stdalign.h> header file.  
  -- Define to 1 if you have the <stdbool.h> header file.  
  -- Define to 1 if you have the <stdint.h> header file.  
  -- Define to 1 if you have the <stdlib.h> header file.  
  -- Define if strerror_l is available in <string.h>.  
  -- #undef _GLIBCXX_HAVE_STRERROR_L  
  -- Define if strerror_r is available in <string.h>.  
  -- #undef _GLIBCXX_HAVE_STRERROR_R  
  -- Define to 1 if you have the <strings.h> header file.  
  -- Define to 1 if you have the <string.h> header file.  
  -- Define to 1 if you have the `strtof' function.  
  -- Define to 1 if you have the `strtold' function.  
  -- Define to 1 if `d_type' is a member of `struct dirent'.  
  -- #undef _GLIBCXX_HAVE_STRUCT_DIRENT_D_TYPE  
  -- Define if strxfrm_l is available in <string.h>.  
  -- #undef _GLIBCXX_HAVE_STRXFRM_L  
  -- Define to 1 if the target runtime linker supports binding the same symbol
  --   to different versions.  

  -- Define to 1 if you have the <sys/filio.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_FILIO_H  
  -- Define to 1 if you have the <sys/ioctl.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_IOCTL_H  
  -- Define to 1 if you have the <sys/ipc.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_IPC_H  
  -- Define to 1 if you have the <sys/isa_defs.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_ISA_DEFS_H  
  -- Define to 1 if you have the <sys/machine.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_MACHINE_H  
  -- Define to 1 if you have the <sys/param.h> header file.  
  -- Define to 1 if you have the <sys/resource.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_RESOURCE_H  
  -- Define to 1 if you have a suitable <sys/sdt.h> header file  
  -- #undef _GLIBCXX_HAVE_SYS_SDT_H  
  -- Define to 1 if you have the <sys/sem.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_SEM_H  
  -- Define to 1 if you have the <sys/statvfs.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_STATVFS_H  
  -- Define to 1 if you have the <sys/stat.h> header file.  
  -- Define to 1 if you have the <sys/sysinfo.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_SYSINFO_H  
  -- Define to 1 if you have the <sys/time.h> header file.  
  -- Define to 1 if you have the <sys/types.h> header file.  
  -- Define to 1 if you have the <sys/uio.h> header file.  
  -- #undef _GLIBCXX_HAVE_SYS_UIO_H  
  -- Define if S_IFREG is available in <sys/stat.h>.  
  -- #undef _GLIBCXX_HAVE_S_IFREG  
  -- Define if S_ISREG is available in <sys/stat.h>.  
  -- Define to 1 if you have the `tanf' function.  
  -- Define to 1 if you have the `tanhf' function.  
  -- Define to 1 if you have the `tanhl' function.  
  -- Define to 1 if you have the `tanl' function.  
  -- Define to 1 if you have the <tgmath.h> header file.  
  -- Define to 1 if the target supports thread-local storage.  
  -- Define to 1 if you have the <uchar.h> header file.  
  -- Define to 1 if you have the <unistd.h> header file.  
  -- Defined if usleep exists.  
  -- Define to 1 if you have the <utime.h> header file.  
  -- Defined if vfwscanf exists.  
  -- Defined if vswscanf exists.  
  -- Defined if vwscanf exists.  
  -- Define to 1 if you have the <wchar.h> header file.  
  -- Defined if wcstof exists.  
  -- Define to 1 if you have the <wctype.h> header file.  
  -- Defined if Sleep exists.  
  -- #undef _GLIBCXX_HAVE_WIN32_SLEEP  
  -- Define if writev is available in <sys/uio.h>.  
  -- #undef _GLIBCXX_HAVE_WRITEV  
  -- Define to 1 if you have the `_acosf' function.  
  -- #undef _GLIBCXX_HAVE__ACOSF  
  -- Define to 1 if you have the `_acosl' function.  
  -- #undef _GLIBCXX_HAVE__ACOSL  
  -- Define to 1 if you have the `_aligned_malloc' function.  
  -- Define to 1 if you have the `_asinf' function.  
  -- #undef _GLIBCXX_HAVE__ASINF  
  -- Define to 1 if you have the `_asinl' function.  
  -- #undef _GLIBCXX_HAVE__ASINL  
  -- Define to 1 if you have the `_atan2f' function.  
  -- #undef _GLIBCXX_HAVE__ATAN2F  
  -- Define to 1 if you have the `_atan2l' function.  
  -- #undef _GLIBCXX_HAVE__ATAN2L  
  -- Define to 1 if you have the `_atanf' function.  
  -- #undef _GLIBCXX_HAVE__ATANF  
  -- Define to 1 if you have the `_atanl' function.  
  -- #undef _GLIBCXX_HAVE__ATANL  
  -- Define to 1 if you have the `_ceilf' function.  
  -- #undef _GLIBCXX_HAVE__CEILF  
  -- Define to 1 if you have the `_ceill' function.  
  -- #undef _GLIBCXX_HAVE__CEILL  
  -- Define to 1 if you have the `_cosf' function.  
  -- #undef _GLIBCXX_HAVE__COSF  
  -- Define to 1 if you have the `_coshf' function.  
  -- #undef _GLIBCXX_HAVE__COSHF  
  -- Define to 1 if you have the `_coshl' function.  
  -- #undef _GLIBCXX_HAVE__COSHL  
  -- Define to 1 if you have the `_cosl' function.  
  -- #undef _GLIBCXX_HAVE__COSL  
  -- Define to 1 if you have the `_expf' function.  
  -- #undef _GLIBCXX_HAVE__EXPF  
  -- Define to 1 if you have the `_expl' function.  
  -- #undef _GLIBCXX_HAVE__EXPL  
  -- Define to 1 if you have the `_fabsf' function.  
  -- #undef _GLIBCXX_HAVE__FABSF  
  -- Define to 1 if you have the `_fabsl' function.  
  -- #undef _GLIBCXX_HAVE__FABSL  
  -- Define to 1 if you have the `_finite' function.  
  -- #undef _GLIBCXX_HAVE__FINITE  
  -- Define to 1 if you have the `_finitef' function.  
  -- Define to 1 if you have the `_finitel' function.  
  -- #undef _GLIBCXX_HAVE__FINITEL  
  -- Define to 1 if you have the `_floorf' function.  
  -- #undef _GLIBCXX_HAVE__FLOORF  
  -- Define to 1 if you have the `_floorl' function.  
  -- #undef _GLIBCXX_HAVE__FLOORL  
  -- Define to 1 if you have the `_fmodf' function.  
  -- #undef _GLIBCXX_HAVE__FMODF  
  -- Define to 1 if you have the `_fmodl' function.  
  -- #undef _GLIBCXX_HAVE__FMODL  
  -- Define to 1 if you have the `_fpclass' function.  
  -- #undef _GLIBCXX_HAVE__FPCLASS  
  -- Define to 1 if you have the `_frexpf' function.  
  -- #undef _GLIBCXX_HAVE__FREXPF  
  -- Define to 1 if you have the `_frexpl' function.  
  -- #undef _GLIBCXX_HAVE__FREXPL  
  -- Define to 1 if you have the `_hypot' function.  
  -- #undef _GLIBCXX_HAVE__HYPOT  
  -- Define to 1 if you have the `_hypotf' function.  
  -- #undef _GLIBCXX_HAVE__HYPOTF  
  -- Define to 1 if you have the `_hypotl' function.  
  -- #undef _GLIBCXX_HAVE__HYPOTL  
  -- Define to 1 if you have the `_isinf' function.  
  -- #undef _GLIBCXX_HAVE__ISINF  
  -- Define to 1 if you have the `_isinff' function.  
  -- #undef _GLIBCXX_HAVE__ISINFF  
  -- Define to 1 if you have the `_isinfl' function.  
  -- #undef _GLIBCXX_HAVE__ISINFL  
  -- Define to 1 if you have the `_isnan' function.  
  -- #undef _GLIBCXX_HAVE__ISNAN  
  -- Define to 1 if you have the `_isnanf' function.  
  -- Define to 1 if you have the `_isnanl' function.  
  -- #undef _GLIBCXX_HAVE__ISNANL  
  -- Define to 1 if you have the `_ldexpf' function.  
  -- #undef _GLIBCXX_HAVE__LDEXPF  
  -- Define to 1 if you have the `_ldexpl' function.  
  -- #undef _GLIBCXX_HAVE__LDEXPL  
  -- Define to 1 if you have the `_log10f' function.  
  -- #undef _GLIBCXX_HAVE__LOG10F  
  -- Define to 1 if you have the `_log10l' function.  
  -- #undef _GLIBCXX_HAVE__LOG10L  
  -- Define to 1 if you have the `_logf' function.  
  -- #undef _GLIBCXX_HAVE__LOGF  
  -- Define to 1 if you have the `_logl' function.  
  -- #undef _GLIBCXX_HAVE__LOGL  
  -- Define to 1 if you have the `_modf' function.  
  -- #undef _GLIBCXX_HAVE__MODF  
  -- Define to 1 if you have the `_modff' function.  
  -- #undef _GLIBCXX_HAVE__MODFF  
  -- Define to 1 if you have the `_modfl' function.  
  -- #undef _GLIBCXX_HAVE__MODFL  
  -- Define to 1 if you have the `_powf' function.  
  -- #undef _GLIBCXX_HAVE__POWF  
  -- Define to 1 if you have the `_powl' function.  
  -- #undef _GLIBCXX_HAVE__POWL  
  -- Define to 1 if you have the `_qfpclass' function.  
  -- #undef _GLIBCXX_HAVE__QFPCLASS  
  -- Define to 1 if you have the `_sincos' function.  
  -- #undef _GLIBCXX_HAVE__SINCOS  
  -- Define to 1 if you have the `_sincosf' function.  
  -- #undef _GLIBCXX_HAVE__SINCOSF  
  -- Define to 1 if you have the `_sincosl' function.  
  -- #undef _GLIBCXX_HAVE__SINCOSL  
  -- Define to 1 if you have the `_sinf' function.  
  -- #undef _GLIBCXX_HAVE__SINF  
  -- Define to 1 if you have the `_sinhf' function.  
  -- #undef _GLIBCXX_HAVE__SINHF  
  -- Define to 1 if you have the `_sinhl' function.  
  -- #undef _GLIBCXX_HAVE__SINHL  
  -- Define to 1 if you have the `_sinl' function.  
  -- #undef _GLIBCXX_HAVE__SINL  
  -- Define to 1 if you have the `_sqrtf' function.  
  -- #undef _GLIBCXX_HAVE__SQRTF  
  -- Define to 1 if you have the `_sqrtl' function.  
  -- #undef _GLIBCXX_HAVE__SQRTL  
  -- Define to 1 if you have the `_tanf' function.  
  -- #undef _GLIBCXX_HAVE__TANF  
  -- Define to 1 if you have the `_tanhf' function.  
  -- #undef _GLIBCXX_HAVE__TANHF  
  -- Define to 1 if you have the `_tanhl' function.  
  -- #undef _GLIBCXX_HAVE__TANHL  
  -- Define to 1 if you have the `_tanl' function.  
  -- #undef _GLIBCXX_HAVE__TANL  
  -- Define to 1 if you have the `__cxa_thread_atexit' function.  
  -- #undef _GLIBCXX_HAVE___CXA_THREAD_ATEXIT  
  -- Define to 1 if you have the `__cxa_thread_atexit_impl' function.  
  -- #undef _GLIBCXX_HAVE___CXA_THREAD_ATEXIT_IMPL  
  -- Define as const if the declaration of iconv() needs const.  
  -- #undef _GLIBCXX_ICONV_CONST  
  -- Define to the sub-directory in which libtool stores uninstalled libraries.
  --    

  -- Name of package  
  -- #undef _GLIBCXX_PACKAGE  
  -- Define to the address where bug reports for this package should be sent.  
  -- Define to the full name of this package.  
  -- Define to the full name and version of this package.  
  -- Define to the one symbol short name of this package.  
  -- Define to the home page for this package.  
  -- Define to the version of this package.  
  -- The size of `char', as computed by sizeof.  
  -- #undef SIZEOF_CHAR  
  -- The size of `int', as computed by sizeof.  
  -- #undef SIZEOF_INT  
  -- The size of `long', as computed by sizeof.  
  -- #undef SIZEOF_LONG  
  -- The size of `short', as computed by sizeof.  
  -- #undef SIZEOF_SHORT  
  -- The size of `void *', as computed by sizeof.  
  -- #undef SIZEOF_VOID_P  
  -- Define to 1 if you have the ANSI C header files.  
  -- Version number of package  
  -- #undef _GLIBCXX_VERSION  
  -- Define if C99 functions in <complex.h> should be used in <complex> for
  --   C++11. Using compiler builtins for these functions requires corresponding
  --   C99 library functions to be present.  

  -- Define if C99 functions or macros in <math.h> should be imported in <cmath>
  --   in namespace std for C++11.  

  -- Define if C99 functions or macros in <stdio.h> should be imported in
  --   <cstdio> in namespace std for C++11.  

  -- Define if C99 functions or macros in <stdlib.h> should be imported in
  --   <cstdlib> in namespace std for C++11.  

  -- Define if C99 functions or macros in <wchar.h> should be imported in
  --   <cwchar> in namespace std for C++11.  

  -- Define if C99 functions in <complex.h> should be used in <complex> for
  --   C++98. Using compiler builtins for these functions requires corresponding
  --   C99 library functions to be present.  

  -- Define if C99 functions or macros in <math.h> should be imported in <cmath>
  --   in namespace std for C++98.  

  -- Define if C99 functions or macros in <stdio.h> should be imported in
  --   <cstdio> in namespace std for C++98.  

  -- Define if C99 functions or macros in <stdlib.h> should be imported in
  --   <cstdlib> in namespace std for C++98.  

  -- Define if C99 functions or macros in <wchar.h> should be imported in
  --   <cwchar> in namespace std for C++98.  

  -- Define if the compiler supports C++11 atomics.  
  -- Define to use concept checking code from the boost libraries.  
  -- #undef _GLIBCXX_CONCEPT_CHECKS  
  -- Define to 1 if a fully dynamic basic_string is wanted, 0 to disable,
  --   undefined for platform defaults  

  -- Define if gthreads library is available.  
  -- #undef _GLIBCXX_HAS_GTHREADS  
  -- Define to 1 if a full hosted library is built, or 0 if freestanding.  
  -- Define if compatibility should be provided for -mlong-double-64.  
  -- Define to the letter to which size_t is mangled.  
  -- Define if C99 llrint and llround functions are missing from <math.h>.  
  -- #undef _GLIBCXX_NO_C99_ROUNDING_FUNCS  
  -- Define if ptrdiff_t is int.  
  -- #undef _GLIBCXX_PTRDIFF_T_IS_INT  
  -- Define if using setrlimit to set resource limits during "make check"  
  -- #undef _GLIBCXX_RES_LIMITS  
  -- Define if size_t is unsigned int.  
  -- #undef _GLIBCXX_SIZE_T_IS_UINT  
  -- Define to the value of the EOF integer constant.  
  -- Define to the value of the SEEK_CUR integer constant.  
  -- Define to the value of the SEEK_END integer constant.  
  -- Define to use symbol versioning in the shared library.  
  -- Define to use darwin versioning in the shared library.  
  -- #undef _GLIBCXX_SYMVER_DARWIN  
  -- Define to use GNU versioning in the shared library.  
  -- Define to use GNU namespace versioning in the shared library.  
  -- #undef _GLIBCXX_SYMVER_GNU_NAMESPACE  
  -- Define to use Sun versioning in the shared library.  
  -- #undef _GLIBCXX_SYMVER_SUN  
  -- Define if C11 functions in <uchar.h> should be imported into namespace std
  --   in <cuchar>.  

  -- Define if C99 functions or macros from <wchar.h>, <math.h>, <complex.h>,
  --   <stdio.h>, and <stdlib.h> can be used or exposed.  

  -- Define if C99 functions in <complex.h> should be used in <tr1/complex>.
  --   Using compiler builtins for these functions requires corresponding C99
  --   library functions to be present.  

  -- Define if C99 functions in <ctype.h> should be imported in <tr1/cctype> in
  --   namespace std::tr1.  

  -- Define if C99 functions in <fenv.h> should be imported in <tr1/cfenv> in
  --   namespace std::tr1.  

  -- Define if C99 functions in <inttypes.h> should be imported in
  --   <tr1/cinttypes> in namespace std::tr1.  

  -- Define if wchar_t C99 functions in <inttypes.h> should be imported in
  --   <tr1/cinttypes> in namespace std::tr1.  

  -- Define if C99 functions or macros in <math.h> should be imported in
  --   <tr1/cmath> in namespace std::tr1.  

  -- Define if C99 types in <stdint.h> should be imported in <tr1/cstdint> in
  --   namespace std::tr1.  

  -- Defined if clock_gettime syscall has monotonic and realtime clock support.
  --    

  -- #undef _GLIBCXX_USE_CLOCK_GETTIME_SYSCALL  
  -- Defined if clock_gettime has monotonic clock support.  
  -- #undef _GLIBCXX_USE_CLOCK_MONOTONIC  
  -- Defined if clock_gettime has realtime clock support.  
  -- #undef _GLIBCXX_USE_CLOCK_REALTIME  
  -- Define if ISO/IEC TR 24733 decimal floating point types are supported on
  --   this host.  

  -- Define if fchmod is available in <sys/stat.h>.  
  -- #undef _GLIBCXX_USE_FCHMOD  
  -- Define if fchmodat is available in <sys/stat.h>.  
  -- #undef _GLIBCXX_USE_FCHMODAT  
  -- Define if __float128 is supported on this host.  
  -- Defined if gettimeofday is available.  
  -- Define if get_nprocs is available in <sys/sysinfo.h>.  
  -- #undef _GLIBCXX_USE_GET_NPROCS  
  -- Define if __int128 is supported on this host.  
  -- Define if LFS support is available.  
  -- Define if code specialized for long long should be used.  
  -- Defined if nanosleep is available.  
  -- #undef _GLIBCXX_USE_NANOSLEEP  
  -- Define if NLS translations are to be used.  
  -- #undef _GLIBCXX_USE_NLS  
  -- Define if pthreads_num_processors_np is available in <pthread.h>.  
  -- #undef _GLIBCXX_USE_PTHREADS_NUM_PROCESSORS_NP  
  -- Define if POSIX read/write locks are available in <gthr.h>.  
  -- #undef _GLIBCXX_USE_PTHREAD_RWLOCK_T  
  -- Define if /dev/random and /dev/urandom are available for the random_device
  --   of TR1 (Chapter 5.1).  

  -- #undef _GLIBCXX_USE_RANDOM_TR1  
  -- Define if usable realpath is available in <stdlib.h>.  
  -- #undef _GLIBCXX_USE_REALPATH  
  -- Defined if sched_yield is available.  
  -- #undef _GLIBCXX_USE_SCHED_YIELD  
  -- Define if _SC_NPROCESSORS_ONLN is available in <unistd.h>.  
  -- #undef _GLIBCXX_USE_SC_NPROCESSORS_ONLN  
  -- Define if _SC_NPROC_ONLN is available in <unistd.h>.  
  -- #undef _GLIBCXX_USE_SC_NPROC_ONLN  
  -- Define if sendfile is available in <sys/sendfile.h>.  
  -- #undef _GLIBCXX_USE_SENDFILE  
  -- Define if struct stat has timespec members.  
  -- #undef _GLIBCXX_USE_ST_MTIM  
  -- Define if sysctl(), CTL_HW and HW_NCPU are available in <sys/sysctl.h>.  
  -- #undef _GLIBCXX_USE_SYSCTL_HW_NCPU  
  -- Define if obsolescent tmpnam is available in <stdio.h>.  
  -- Define if utimensat and UTIME_OMIT are available in <sys/stat.h> and
  --   AT_FDCWD in <fcntl.h>.  

  -- #undef _GLIBCXX_USE_UTIMENSAT  
  -- Define if code specialized for wchar_t should be used.  
  -- Define to 1 if a verbose library is built, or 0 otherwise.  
  -- Defined if as can handle rdrand.  
  -- Define to 1 if mutex_timedlock is available.  
  -- Define if all C++11 floating point overloads are available in <math.h>.   
  -- #undef __CORRECT_ISO_CPP11_MATH_H_PROTO_FP  
  -- Define if all C++11 integral type overloads are available in <math.h>.   
  -- #undef __CORRECT_ISO_CPP11_MATH_H_PROTO_INT  
end cppconfig_h;
