with Task_Ids; use Task_Ids;

package Containers is

   Max_Container_Size : constant := 100;
   type Container_Range_T is range 0 .. Max_Container_Size;
   Default_Container_Size : constant Container_Range_T := 10;    
   
  
   -- Task used by each container to retrieve its unique Id
   Container_Ids_Provider : Task_Id_T;
   
   -- Create a task type Containers_T with a discriminant Size of type Container_Range_T
   -- with the default value Default_Container_Size
   -- The task type Containers_T accepts 2 entries:
   --     - Add taking one parameter Quantity of type Integer 
   --     - Remove without parameter
   -- The container starts empty 
   -- The Add entry will add the Quantity to the existing quantity stored in the container
   -- The Remove entry will decrease by 1 the quantity stored 
   -- A message should be displayed with the Container task Id on each operation
   -- If the container cannot handle the requested quantity then an overflow message is displayed
   -- If the container is empty when Remove is called then a message is displayed
  

end Containers;
