with Ada.Calendar; use Ada.Calendar;
with Ada.Numerics.Float_Random; use Ada.Numerics.Float_Random;
with Ada.Text_IO; use Ada.Text_IO;

package body Containers.Fillers is

   --------------
   -- Filler_T --
   --------------

  task body Filler_T is
      Id : Positive;
      Assigned_Container : Container_Access_T;
      Next_Step : Ada.Calendar.Time;
      P : Duration;
      G : Generator;
      Quantity : Integer;
      Stopped : Boolean := False;
   begin
      Filler_Ids_Provider.Create_Id (Id);
      Reset (G);
      accept Start(Period : Duration; Container :  Container_Access_T) do
         Assigned_Container := Container;
         P := Period;
         Next_Step := Clock + Period;
      end Start;
      Put_Line ("Filler "&Id'Img &":Started");
      loop
         Quantity := Integer(Random (G) * 10.0);

         Put_Line ("Filler "&Id'Img & ":Adding "&Quantity'Img);
         Assigned_Container.all.Add(Quantity);
         select
            accept Stop do
               Stopped := True;
            end ;
         else
            null;
         end select;
         if Stopped then
            exit;
         end if;
         delay until Next_Step;
         Next_Step := Next_Step + P;
      end loop;
      Put_Line ("Filler "&Id'Img &":Stopped");

   end Filler_T;

end Containers.Fillers;
