with Ada.Calendar; use Ada.Calendar;
with Ada.Text_IO; use Ada.Text_IO;

package body Containers.Remover is

   ---------------
   -- Remover_T --
   ---------------

   task body Remover_T is
      Id : Positive;
      Assigned_Container : Container_Access_T;
      Next_Step : Ada.Calendar.Time;
      P : Duration;
      Stopped : Boolean := False;
   begin
      Remover_Ids_Provider.Create_Id (Id);
      accept Start(Period : Duration; Container :  Container_Access_T) do
         Assigned_Container := Container;
         P := Period;
         Next_Step := Clock + Period;
      end Start;
      Put_Line ("Remover "&Id'Img &":Started");

      loop
         Put_Line ("Remover "&Id'Img & ":Removing");
         select
            Assigned_Container.all.Remove;
         or
            delay 5.0;
            Stopped := True;
         end select;
         if Stopped then
            exit;
         end if;
         delay until Next_Step;
         Next_Step := Next_Step + P;
      end loop;
      Put_Line ("Remover "&Id'Img &":Stopped");
   end Remover_T;

end Containers.Remover;
