with Ada.Calendar; use Ada.Calendar;
with Ada.Text_IO; use Ada.Text_IO;
with Ada.Numerics.Float_Random; use Ada.Numerics.Float_Random;
with OverflowManagers; use OverflowManagers;

package body Containers is

   -----------------
   -- Container_T --
   -----------------

   task body Container_T is
      Id : Positive;
      Value : Container_Range_T := 0;
      OM : aliased Overflow_Manager_T;
   begin
      Container_Ids_Provider.Create_Id(Id);
      OM.Start(Container_T'Unchecked_Access);
      loop
         select
            accept Add(Quantity : Integer) do
               Put_Line ("Container " & Id'Img & ":Current="&Value'Img & ":Add=" & Quantity'Img);
               if Value  > Size - Container_Range_T(Quantity)then
                  Put_Line ("Container " & Id'Img & ":Overflow");
                  requeue OM.Add;
               else
                  Value := Value + Container_Range_T(Quantity);
                  Put_Line ("Container " & Id'Img & ":Added=" & Quantity'Img&":Current="&Value'Img);
               end if;
            end Add;
         or
            when Value /= Container_Range_T'First => accept Remove  do
                  if Value = Container_Range_T'First then
                  Put_Line ("Container " & Id'Img & ":Remove:Empty");
               else
                  Value := Value - 1;
                  Put_Line ("Container " & Id'Img & ":Remove:Current="&Value'Img);
               end if;
            end Remove;
         or
            terminate;
         end select;
      end loop;
    end Container_T;





end Containers;
