with Ada.Text_IO; use Ada.Text_IO;
with Containers; use Containers;
with Containers.Remover; use Containers.Remover;
package body OverflowManagers is

   ------------------------
   -- Overflow_Manager_T --
   ------------------------

   task body Overflow_Manager_T is
      Overflow : Integer := 0;
      Assigned_Container : Container_Access_T;
      Remover : access Remover_T;
   begin
      accept Start(Container : Container_Access_T) do
         Assigned_Container := Container;
      end Start;

      loop
         select
            accept Add (Quantity : Integer) do
               Overflow := Overflow + Quantity;
               Put_Line ("OM : Add " & Quantity'Image & " Total = " & Overflow'Image);
               Remover := new Remover_T;
               Remover.Start(Period    => 0.1,
                             Container => Assigned_Container);
            end Add;
         or
            terminate;
         end select;
      end loop;

   end Overflow_Manager_T;

end OverflowManagers;
